#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ProcedureVizDefinitionV2 {
    #[builder(default, into)]
    #[serde(rename = "title", skip_serializing_if = "Option::is_none", default)]
    title: Option<String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::ProcedureVizId>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "procedure", skip_serializing_if = "Option::is_none", default)]
    procedure: Option<Box<super::ProcedureVizId>>,
}
impl ProcedureVizDefinitionV2 {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn title(&self) -> Option<&str> {
        self.title.as_ref().map(|o| &**o)
    }
    /// A workbook can save either an execution or a template. Workbook templates should only use the latter.
    #[inline]
    pub fn procedure(&self) -> Option<&super::ProcedureVizId> {
        self.procedure.as_ref().map(|o| &**o)
    }
}
